// This file was generated by qtwaylandscanner
// source file is /usr/share/deepin-wayland-protocols/dde-restrict.xml

#include "qwayland-server-dde-restrict.h"

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")

namespace QtWaylandServer {

    int dde_restrict::deferred_destroy_global_func(void *data) {
        auto object = static_cast<dde_restrict *>(data);
        wl_global_destroy(object->m_global);
        object->m_global = nullptr;
        wl_event_source_remove(object->m_globalRemovedEvent);
        object->m_globalRemovedEvent = nullptr;
        wl_list_remove(&object->m_displayDestroyedListener.link);
        object->dde_restrict_destroy_global();
        return 0;
    }

    dde_restrict::dde_restrict(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
        , m_display(nullptr)
        , m_globalRemovedEvent(nullptr)
    {
        init(client, id, version);
    }

    dde_restrict::dde_restrict(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
        , m_display(nullptr)
        , m_globalRemovedEvent(nullptr)
    {
        init(display, version);
    }

    dde_restrict::dde_restrict(struct ::wl_resource *resource)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
        , m_display(nullptr)
        , m_globalRemovedEvent(nullptr)
    {
        init(resource);
    }

    dde_restrict::dde_restrict()
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
        , m_display(nullptr)
        , m_globalRemovedEvent(nullptr)
    {
    }

    dde_restrict::~dde_restrict()
    {
        for (auto resource : std::as_const(m_resource_map))
            resource->dde_restrict_object = nullptr;

        if (m_resource)
            m_resource->dde_restrict_object = nullptr;

        if (m_global) {
            if (m_globalRemovedEvent)
                wl_event_source_remove(m_globalRemovedEvent);
            wl_global_destroy(m_global);
            wl_list_remove(&m_displayDestroyedListener.link);
        }
    }

    void dde_restrict::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    void dde_restrict::init(struct ::wl_resource *resource)
    {
        m_resource = bind(resource);
    }

    dde_restrict::Resource *dde_restrict::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    dde_restrict::Resource *dde_restrict::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void dde_restrict::init(struct ::wl_display *display, int version)
    {
        m_display = display;
        m_global = wl_global_create(display, &::dde_restrict_interface, version, this, bind_func);
        m_displayDestroyedListener.notify = dde_restrict::display_destroy_func;
        m_displayDestroyedListener.parent = this;
        wl_display_add_destroy_listener(display, &m_displayDestroyedListener);
    }

    const struct wl_interface *dde_restrict::interface()
    {
        return &::dde_restrict_interface;
    }

    dde_restrict::Resource *dde_restrict::dde_restrict_allocate()
    {
        return new Resource;
    }

    void dde_restrict::dde_restrict_destroy_global()
    {
    }

    void dde_restrict::dde_restrict_bind_resource(Resource *)
    {
    }

    void dde_restrict::dde_restrict_destroy_resource(Resource *)
    {
    }

    void dde_restrict::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        dde_restrict *that = static_cast<dde_restrict *>(data);
        that->add(client, id, version);
    }

    void dde_restrict::display_destroy_func(struct ::wl_listener *listener, void *data)
    {
        Q_UNUSED(data);
        dde_restrict *that = static_cast<dde_restrict::DisplayDestroyedListener *>(listener)->parent;
        that->m_global = nullptr;
        that->m_globalRemovedEvent = nullptr;
    }

    void dde_restrict::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        Q_ASSERT(resource);
        dde_restrict *that = resource->dde_restrict_object;
        if (Q_LIKELY(that)) {
            that->m_resource_map.remove(resource->client(), resource);
            that->dde_restrict_destroy_resource(resource);

            that = resource->dde_restrict_object;
            if (that && that->m_resource == resource)
                that->m_resource = nullptr;
        }
        delete resource;
    }


    void dde_restrict::globalRemove()
    {
        if (!m_global || m_globalRemovedEvent)
            return;

        wl_global_remove(m_global);

        struct wl_event_loop *event_loop = wl_display_get_event_loop(m_display);
        m_globalRemovedEvent = wl_event_loop_add_timer(event_loop, deferred_destroy_global_func, this);
        wl_event_source_timer_update(m_globalRemovedEvent, 5000);
    }

    dde_restrict::Resource *dde_restrict::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Q_ASSERT_X(!wl_client_get_object(client, id), "QWaylandObject bind", QStringLiteral("binding to object %1 more than once").arg(id).toLocal8Bit().constData());
        struct ::wl_resource *handle = wl_resource_create(client, &::dde_restrict_interface, version, id);
        return bind(handle);
    }

    dde_restrict::Resource *dde_restrict::bind(struct ::wl_resource *handle)
    {
        Resource *resource = dde_restrict_allocate();
        resource->dde_restrict_object = this;

        wl_resource_set_implementation(handle, &m_dde_restrict_interface, resource, destroy_func);
        resource->handle = handle;
        dde_restrict_bind_resource(resource);
        return resource;
    }
    dde_restrict::Resource *dde_restrict::Resource::fromResource(struct ::wl_resource *resource)
    {
        if (Q_UNLIKELY(!resource))
            return nullptr;
        if (wl_resource_instance_of(resource, &::dde_restrict_interface, &m_dde_restrict_interface))
            return static_cast<Resource *>(wl_resource_get_user_data(resource));
        return nullptr;
    }

    const struct ::dde_restrict_interface dde_restrict::m_dde_restrict_interface = {
        dde_restrict::handle_switch_screencast,
        dde_restrict::handle_client_whitelist,
        dde_restrict::handle_set_protected_window,
        dde_restrict::handle_remove_protected_window
    };

    void dde_restrict::dde_restrict_switch_screencast(Resource *, uint32_t )
    {
    }

    void dde_restrict::dde_restrict_client_whitelist(Resource *, const QString &)
    {
    }

    void dde_restrict::dde_restrict_set_protected_window(Resource *, int32_t )
    {
    }

    void dde_restrict::dde_restrict_remove_protected_window(Resource *, int32_t )
    {
    }


    void dde_restrict::handle_switch_screencast(
        ::wl_client *client,
        struct wl_resource *resource,
        uint32_t switch_flag)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        if (Q_UNLIKELY(!r->dde_restrict_object)) {
            return;
        }
        static_cast<dde_restrict *>(r->dde_restrict_object)->dde_restrict_switch_screencast(
            r,
            switch_flag);
    }

    void dde_restrict::handle_client_whitelist(
        ::wl_client *client,
        struct wl_resource *resource,
        const char *whitelists)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        if (Q_UNLIKELY(!r->dde_restrict_object)) {
            return;
        }
        static_cast<dde_restrict *>(r->dde_restrict_object)->dde_restrict_client_whitelist(
            r,
            QString::fromUtf8(whitelists));
    }

    void dde_restrict::handle_set_protected_window(
        ::wl_client *client,
        struct wl_resource *resource,
        int32_t window)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        if (Q_UNLIKELY(!r->dde_restrict_object)) {
            return;
        }
        static_cast<dde_restrict *>(r->dde_restrict_object)->dde_restrict_set_protected_window(
            r,
            window);
    }

    void dde_restrict::handle_remove_protected_window(
        ::wl_client *client,
        struct wl_resource *resource,
        int32_t window)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        if (Q_UNLIKELY(!r->dde_restrict_object)) {
            return;
        }
        static_cast<dde_restrict *>(r->dde_restrict_object)->dde_restrict_remove_protected_window(
            r,
            window);
    }

    void dde_restrict::send_loged(const QString &log)
    {
        Q_ASSERT_X(m_resource, "dde_restrict::loged", "Uninitialised resource");
        if (Q_UNLIKELY(!m_resource)) {
            qWarning("could not call dde_restrict::loged as it's not initialised");
            return;
        }
        send_loged(
            m_resource->handle,
            log);
    }

    void dde_restrict::send_loged(struct ::wl_resource *resource, const QString &log)
    {
        dde_restrict_send_loged(
            resource,
            log.toUtf8().constData());
    }

}

QT_WARNING_POP
QT_END_NAMESPACE
